'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _mapping = require('./mapping');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var reLodash = RegExp('/lodash(?:-amd|-es)?/');

var LodashModuleReplacementPlugin = function () {
  function LodashModuleReplacementPlugin(options) {
    _classCallCheck(this, LodashModuleReplacementPlugin);

    options || (options = {});
    var replacements = this.replacements = [];
    _lodash2.default.forOwn(_mapping.features, function (pairs, key) {
      if (!options[key]) {
        _lodash2.default.each(pairs, function (pair) {
          replacements.push(['/' + pair[0] + '.js', './' + pair[1] + '.js']);
        });
      }
    });
  }

  _createClass(LodashModuleReplacementPlugin, [{
    key: 'apply',
    value: function apply(compiler) {
      var replacements = this.replacements;
      compiler.plugin('normal-module-factory', function (nmf) {
        nmf.plugin('after-resolve', function (result, callback) {
          if (!result) {
            return callback();
          }
          var resource = result.resource;

          if (reLodash.test(resource)) {
            var length = replacements.length;

            while (length--) {
              var pair = replacements[length];
              if (_lodash2.default.endsWith(resource, pair[0])) {
                result.resource = _path2.default.resolve(_path2.default.dirname(resource), pair[1]);
                break;
              }
            }
          }
          return callback(null, result);
        });
      });
    }
  }]);

  return LodashModuleReplacementPlugin;
}();

exports.default = LodashModuleReplacementPlugin;
;
module.exports = exports['default'];